//*# nonModule !
import Routes from './routes.js'
import Handler from './handler.js'
import HandlerCtx from './handler-ctx.js'
import HandlerRequest from './handler-request.js'
import Assets from './assets.js'

export default
//*/

/**
 * HrProxy class is responsible for handling `proxy` communication method.
 */
class HrProxy {
    /**
     * Route manager for the current `Proxy` server.
     */
    public readonly routes: Routes

    /**
     * Asset (images, css, js etc.) manager for the current `Proxy` server.
     */
    public readonly assets: Assets

    /**
     * HTTP Relay proxy server endpoint URL
     */
    public readonly serverUrl: URL

    private errRetry: number = 0
    private readonly abortCtrl: AbortController
    private readonly abortSig: AbortSignal

    /**
     * Creates `Proxy` communication method object. Should not be used directly.
     * Please use {@link HttpRelay.proxy} method to instantiate this class.
     */
    constructor(
        public readonly proxyUrl: URL,
        public readonly baseUrl: URL,
        public readonly serverId: string,
        public readonly wSecret: string,
        public readonly assetPathPrefix: string
    ) {
        // WARNING!!! State is shared between parallel requests!
        this.serverUrl = new URL(this.serverId+'/', this.proxyUrl)
        this.routes = new Routes(this.serverUrl)
        this.assets = new Assets(this.routes, this.baseUrl, this.assetPathPrefix)
        this.abortCtrl = new AbortController()
        this.abortSig = this.abortCtrl.signal
    }

    /**
     * Start serving client requests.
     * @param parallel - count of "parallel" handlers (not really parallel but good enough, for better performance web workers needs to be implemented).
     */
    public start(parallel=4): void {
        window?.addEventListener('beforeunload', () => this.stop())
        for (let i=0; i<parallel; i++) this.serve()
    }

    /**
     * Stop serving client requests.
     */
    public stop(): void {
        this.abortCtrl.abort()
    }

    private serve(init = Handler.requestInit(this.abortSig, this.wSecret)) {
        if (!this.abortSig.aborted) {
            fetch(this.serverUrl.href, init).then(
                resp => {
                    if (resp.status === 200) {
                        this.errRetry = 0

                        let handlerRequest = new HandlerRequest(resp)
                        let selectedRoute = this.routes.find(handlerRequest.method, handlerRequest.path)
                        let ctx = new HandlerCtx(handlerRequest, this.abortSig, selectedRoute.params, this.routes, this.assets)
                        let handler = new Handler(selectedRoute.handlerFunc, this.wSecret)
                        handler.execute(ctx).then(
                            init => this.serve(init),
                            err => this.retry(err)
                        )
                    } else {
                        let errMsg = `HttpRelay responded ${resp.status} while returning result and requesting new job.`
                        if (resp.status >= 500 && resp.status <= 599) {
                            this.retry(errMsg)
                        } if (resp.status == 406) {
                            console.warn(errMsg, ' Client is gone, nowhere to forward the response.')
                            this.serve()
                        } else {
                            if (resp.status == 401) errMsg += ' Make sure that provided `wSecret` is correct. If not set, it is autogenerated each time `proxy` object is created and most of the time it is the reason you get this error.'
                            throw errMsg
                        }
                    }
                },
                err => this.retry(err, init)
            )
        }
    }

    private retry(err: string, init: RequestInit=Handler.requestInit(this.abortSig)) {
        if (!this.abortSig.aborted) {
            setTimeout(() => this.serve(init), this.errRetry++ * 1000)
            throw err
        }
    }
}